import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/material.dart';

class AdsCarousel extends StatefulWidget {
  final List<Widget> listItems;
  final EdgeInsets paddingCarousel;
  final Color colorBackgroundCarousel;
  final AlignmentGeometry positionCarousel;
  final Duration durationSlideCarousel;
  final num showCarouselHeight;
  final bool enlargeCenterPageCarousel;
  final double carouselProportionToScreen;
  final bool autoplayCarousel;
  final bool reverseCarousel;
  final double aspectRatioCarousel;

  const AdsCarousel({
    Key? key,
    required this.listItems,
    this.paddingCarousel = const EdgeInsets.only(top: 15, bottom: 15),
    this.colorBackgroundCarousel = Colors.white,
    this.positionCarousel = Alignment.topCenter,
    this.showCarouselHeight = 1024,
    this.enlargeCenterPageCarousel = true,
    this.carouselProportionToScreen = 4,
    this.autoplayCarousel = true,
    this.reverseCarousel = false,
    this.aspectRatioCarousel = 2.0,
    required this.durationSlideCarousel,
  }) : super(key: key);

  @override
  State<AdsCarousel> createState() => _AdsCarouselState();
}

class _AdsCarouselState extends State<AdsCarousel> {
  @override
  Widget build(BuildContext context) {
    return Visibility(
      visible: (MediaQuery.of(context).size.height > widget.showCarouselHeight),
      child: Positioned.fill(
        child: Align(
          alignment: widget.positionCarousel,
          child: Container(
            padding: widget.paddingCarousel,
            color: widget.colorBackgroundCarousel,
            child: CarouselSlider(
              items: widget.listItems,
              options: CarouselOptions(
                enlargeCenterPage: widget.enlargeCenterPageCarousel,
                height: (MediaQuery.of(context).size.height /
                    widget.carouselProportionToScreen),
                autoPlay: widget.autoplayCarousel,
                autoPlayInterval: widget.durationSlideCarousel,
                reverse: widget.reverseCarousel,
                aspectRatio: widget.aspectRatioCarousel,
              ),
            ),
          ),
        ),
      ),
    );
  }
}
